=== modified file 'bzrlib/directory_service.py'
--- bzrlib/directory_service.py	2008-06-26 05:10:31 +0000
+++ bzrlib/directory_service.py	2008-06-26 06:03:36 +0000
@@ -58,8 +58,8 @@
 class AliasDirectory(object):
     """Directory lookup for locations associated with a branch.
 
-    :parent, :submit, :public, and :bound are currently supported.  On error,
-    a subclass of DirectoryLookupFailure will be raised.
+    :parent, :submit, :public, :push, :this,and :bound are currently
+    supported.  On error, a subclass of DirectoryLookupFailure will be raised.
     """
 
     def look_up(self, name, url):
@@ -69,6 +69,8 @@
             'submit': branch.get_submit_branch,
             'public': branch.get_public_branch,
             'bound': branch.get_bound_location,
+            'push': branch.get_push_location,
+            'this': lambda: branch.base
         }
         try:
             method = lookups[url[1:]]

=== modified file 'bzrlib/tests/test_directory_service.py'
--- bzrlib/tests/test_directory_service.py	2008-06-26 05:10:31 +0000
+++ bzrlib/tests/test_directory_service.py	2008-06-26 06:03:36 +0000
@@ -74,6 +74,15 @@
         branch.set_bound_location('http://d')
         self.assertEqual('http://d', directories.dereference(':bound'))
 
+    def test_lookup_push(self):
+        branch = self.make_branch('.')
+        branch.set_push_location('http://e')
+        self.assertEqual('http://e', directories.dereference(':push'))
+
+    def test_lookup_this(self):
+        branch = self.make_branch('.')
+        self.assertEqual(branch.base, directories.dereference(':this'))
+
     def test_lookup_badname(self):
         branch = self.make_branch('.')
         e = self.assertRaises(errors.InvalidLocationAlias,

